#include <windows.h>
#include <stdio.h>
#include "flopio.h"

LPDCB		lpdcb;

void main(int argc, char *argv[])
{
    HANDLE	hCom;
//    OVERLAPPED	o;
//    BOOL	fSuccess;
    int		rd=0, wr=0;
    BYTE	p1,p2;
    FILE	*inf;
    char	*diskA;
    int		disk0t = 0;
	int		numfloppy = 0;	// floppy A:

	printf("Windows Server for PYLDIN terminal\n\n");

    if (argc < 2) {
	printf("PYLDIN must be connected to COM2:\n\n");
	printf("Usage:\twinserv { A: | B: | diskimage_Name }\n\n");
	printf("\twhere diskimage_Name - name of file with diskimage,\n\t10 MegaBytes diskimages are supported\n");
	exit(0);
    }

    hCom = CreateFile("COM2",
	GENERIC_READ | GENERIC_WRITE,
	0, /* exclusive access */
	NULL, /* no security attrs */
	OPEN_EXISTING,
	FILE_FLAG_OVERLAPPED,
	NULL
    );
    if (hCom == INVALID_HANDLE_VALUE) {
	printf("\07COM2: INVALID HANDLE VALUE!\n");
	exit(-3);
    }

    lpdcb = (LPDCB)malloc(sizeof(DCB));

    if (!GetCommState(hCom, lpdcb)){
	printf("\07COM2: error: -1 ?\n");
	exit(-1);
    }
    lpdcb->StopBits = 2; // 2 stop bits
    lpdcb->BaudRate = CBR_56000;
    lpdcb->fBinary = TRUE;
    lpdcb->fOutxCtsFlow = FALSE;
    lpdcb->fOutxDsrFlow = FALSE;

    printf("bytesize = %d\n",lpdcb->ByteSize);
    printf("stopbits = %d\n",lpdcb->StopBits);
    printf("parity   = %d\n",lpdcb->Parity);
    printf("baud     = %d\n",lpdcb->BaudRate);
	
    if (!SetCommState(hCom, lpdcb)){
	printf("\07\nCOM2: error: -2 ?\n");
	exit(-2);
    }

    diskA = (char *)malloc(512);

    if (strcmp(argv[1],"a:")==0 || strcmp(argv[1],"A:")==0) {
	printf("\nUse real floppy A:\n");
	openVWIN32();
	disk0t = 1;
    } else if (strcmp(argv[1],"b:")==0 || strcmp(argv[1],"B:")==0) {
	printf("\nUse real floppy B:\n");
	openVWIN32();
	disk0t = 1;
	numfloppy = 1;	// floppy B:
    } else {
	inf = fopen(argv[1], "rb+");
	if (!inf) {
		printf("\07\nCan not open diskimage file\n");
		exit(-4);
	}
	fseek(inf, 0, SEEK_END);
	printf("\nUse diskimage, size: %d\n", ftell(inf));
   }

    DWORD nBytesToRead = 1;
    DWORD nBytesRead = 0;

    char c=0;
	printf("\nUse Ctrl-C or Ctrl-Break to exit\n\n");
    while(1){
	printf("send = %d bytes, recv = %d bytes\r", rd, wr); fflush(stdout);
	BOOL bResult = ReadFile(hCom, &c, 1, &nBytesRead, NULL) ; 

	switch(c) {
	    case 'I':
		printf("Initialization, Pyldin started! :)\n");
		break;

	    case 'R': {
		bResult = ReadFile(hCom, &p1, 1, &nBytesRead, NULL) ; 
		bResult = ReadFile(hCom, &p2, 1, &nBytesRead, NULL) ; 
		int p = (p1<<8)+p2;
		int s=0;
		if (disk0t==0) {
			fseek(inf, p*512, SEEK_SET);
			fread(diskA, 1, 512, inf);
		} else readSec(numfloppy, p, diskA);
		for (int qi = 0; qi < 512; qi++) {
		    bResult = WriteFile(hCom, diskA+qi, 1, &nBytesRead, NULL); 
		}
		p=p+s;
		rd+=512;
		break;
	    }
	    case 'W': {
		bResult = ReadFile(hCom, &p1, 1, &nBytesRead, NULL); 
		bResult = ReadFile(hCom, &p2, 1, &nBytesRead, NULL); 
		int p = (p1<<8)+p2;
		for (int qi = 0; qi < 512; qi++) {
		    bResult = ReadFile(hCom, diskA+qi, 1, &nBytesRead, NULL); 
		}
		if (disk0t==0) {
			fseek(inf, p*512, SEEK_SET);
			fwrite(diskA, 1, 512, inf);
		} else writeSec(numfloppy, p, diskA);
		wr+=512;
		break;
	   }
	    case 'i':
		printf("drvA! :)\n");
		openVWIN32();
		break;

	    case 'r': {
		bResult = ReadFile(hCom, &p1, 1, &nBytesRead, NULL) ; 
		bResult = ReadFile(hCom, &p2, 1, &nBytesRead, NULL) ; 
		int p = (p1<<8)+p2;
		int s=0;
//		if (disk0t==0) {
//			fseek(inf, p*512, SEEK_SET);
//			fread(diskA, 1, 512, inf);
//		} else 
			readSec(numfloppy, p, diskA);
		for (int qi = 0; qi < 512; qi++) {
		    bResult = WriteFile(hCom, diskA+qi, 1, &nBytesRead, NULL); 
		}
		p=p+s;
		rd+=512;
		break;
	    }
	    case 'w': {
		bResult = ReadFile(hCom, &p1, 1, &nBytesRead, NULL); 
		bResult = ReadFile(hCom, &p2, 1, &nBytesRead, NULL); 
		int p = (p1<<8)+p2;
		for (int qi = 0; qi < 512; qi++) {
		    bResult = ReadFile(hCom, diskA+qi, 1, &nBytesRead, NULL); 
		}
//		if (disk0t==0) {
//			fseek(inf, p*512, SEEK_SET);
//			fwrite(diskA, 1, 512, inf);
//		} else 
			writeSec(numfloppy, p, diskA);
		wr+=512;
		break;
	   }
	   default: {
		printf("\nUnknown command: %d\n", c);
//		c = -c;
//		bResult = WriteFile(hCom, &c, 1, &nBytesRead, NULL); 
		break;
	   }
	}

    }

    CloseHandle(hCom);
}
